package com.gwidgets.resources;

import jakarta.ws.rs.GET;
import jakarta.ws.rs.Produces;
import jakarta.ws.rs.QueryParam;
import jakarta.ws.rs.core.MediaType;
import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.ext.Provider;
import org.keycloak.models.KeycloakSession;
import org.keycloak.representations.idm.UserRepresentation;
import java.util.List;
import org.keycloak.models.utils.ModelToRepresentation;
import java.util.stream.*;

@Provider
public class ApiKeyResource {

    private final KeycloakSession session;

    public ApiKeyResource(KeycloakSession session) {
        this.session = session;
    }

    @GET
    @Produces("application/json")
    public List<UserRepresentation> checkApiKey(@QueryParam("apiKey") String apiKey) {
        var user = session.users().searchForUserByUserAttributeStream(session.getContext().getRealm(), "api-key", apiKey)
		.map(userModel -> ModelToRepresentation.toRepresentation(session, session.getContext().getRealm(), userModel))
                                .collect(Collectors.toList());
	return user;	    
    }
}
